码迷,mamicode.com
首页 > 其他好文 > 详细

ACM-ICPC 2018 南京赛区网络预赛 E AC Challenge 状压DP

时间:2018-09-01 21:51:25      阅读:223      评论:0      收藏:0      [点我收藏+]

标签:however   tps   com   vertica   状压dp   lan   icpc   bin   esc   

题目链接: https://nanti.jisuanke.com/t/30994

Dlsj is competing in a contest with n (0 < n \le 20)n(0<n20) problems. And he knows the answer of all of these problems.

However, he can submit ii-th problem if and only if he has submitted (and passed, of course) s_isi? problems, the p_{i, 1}pi,1?-th, p_{i, 2}pi,2?-th, ......, p_{i, s_i}pi,si??-th problem before.(0 < p_{i, j} \le n,0 < j \le s_i,0 < i \le n)(0<pi,j?n,0<jsi?,0<in) After the submit of a problem, he has to wait for one minute, or cooling down time to submit another problem. As soon as the cooling down phase ended, he will submit his solution (and get "Accepted" of course) for the next problem he selected to solve or he will say that the contest is too easy and leave the arena.

"I wonder if I can leave the contest arena when the problems are too easy for me."
"No problem."
—— CCF NOI Problem set

If he submits and passes the ii-th problem on tt-th minute(or the tt-th problem he solve is problem ii), he can get t \times a_i + b_it×ai?+bi? points. (|a_i|, |b_i| \le 10^9)(ai?,bi?109).

Your task is to calculate the maximum number of points he can get in the contest.

Input

The first line of input contains an integer, nn, which is the number of problems.

Then follows nn lines, the ii-th line contains s_i + 3si?+3 integers, a_i,b_i,s_i,p_1,p_2,...,p_{s_i}ai?,bi?,si?,p1?,p2?,...,psi??as described in the description above.

Output

Output one line with one integer, the maximum number of points he can get in the contest.

Hint

In the first sample.

On the first minute, Dlsj submitted the first problem, and get 1 \times 5 + 6 = 111×5+6=11 points.

On the second minute, Dlsj submitted the second problem, and get 2 \times 4 + 5 = 132×4+5=13 points.

On the third minute, Dlsj submitted the third problem, and get 3 \times 3 + 4 = 133×3+4=13 points.

On the forth minute, Dlsj submitted the forth problem, and get 4 \times 2 + 3 = 114×2+3=11 points.

On the fifth minute, Dlsj submitted the fifth problem, and get 5 \times 1 + 2 = 75×1+2=7 points.

So he can get 11+13+13+11+7=5511+13+13+11+7=55 points in total.

In the second sample, you should note that he doesn‘t have to solve all the problems.

样例输入1

5
5 6 0
4 5 1 1
3 4 1 2
2 3 1 3
1 2 1 4

样例输出1

55

样例输入2

1
-100 0 0

样例输出2

0

给n个问题,然后每个问题 给出a,b,s 分别表示 第i个解决这个题,就给 (a*i+b) 的收益,s表示有 s个前置问题,必须回答出来 s个前置问题 才能解决这个问题

之前没有写过状压DP, 但是了解过旅行商问题,所以,感觉这个题目暴力莽,就能过了

dp[state] 中 state按照每个2进制位,如果为1,代表这个题被解决,所以,dp[state] 表示 相应位为1的题目都被解决的 最大收益(因为每个题解决的顺序不同,所以可能有不同的收益,但是我们 状态表示的是最大收益)

然后我们可以用 pre[i] 表示想要解决第 i 个问题,需要解决的问题的(二进制为1)集合

接着我们就可以DP了

用cnt[state] 表示 state这个状态之前已经解决多少个问题了

对于第 i 次

  对于 第 j 个问题

    对于 每个状态k 

      如果状态k

        如果 已经解决 i-1个问题 && 状态 k 没解决第j个问题 && 状态k 已经解决了第j个问题的 前置问题

        分别对应  cnt[k] == i-1  &&  ((k>>j)&1)==0  && (k&pre[j]) ==pre[j]

        那么  state = k+(1<<j) ,这个状态 dp[state] 就可以更新成 第i次解决 j题的收益+dp[k]

但是 这里我们这里还是过不了问题 , 还要保证一个条件 即  k+(1<<j)  < (1<<n) 必须可以更新的状态 小于 (1<<n),超过的状态 无用,会得出错误的结果 

#include<bits/stdc++.h>
using namespace std;

const int N =1<<21;
typedef long long ll;


int n,a[25],b[25],pre[25];
ll dp[N],cnt[N];

void solve() {
    dp[0] = 0;
    ll res = 0;
    for(int i=1; i<=n; i++) {
        for(int j=0; j<n; j++) {
            for(int k=0; k<(1<<n); k++) {
                if(cnt[k]!=i-1 || ((k>>j)&1)==1 || (k&pre[j])!=pre[j])continue;
                if(k+(1<<j) >=(1<<n)) continue;
                if(dp[k]+1LL*a[j]*i+b[j] >= dp[k+(1<<j)]) {
                    dp[k+(1<<j)] = dp[k]+a[j]*i+b[j];
                    cnt[k+(1<<j)] = cnt[k]+1;
                    res = max(res, dp[k+(1<<j)]);
                }
            }
        }
    }
    cout << res <<endl;
}

int main ()
{
    //freopen("in.txt","r",stdin);
    scanf("%d", &n);
    for(int i=0; i<n; i++)
    {
        int T;
        scanf("%d %d %d",&a[i], &b[i], &T);
        while (T--) {
            int k; scanf("%d",&k);
            pre[i] |= (1<<(k-1));
        }
    }
    solve();
    return 0;
}

 

ACM-ICPC 2018 南京赛区网络预赛 E AC Challenge 状压DP

标签:however   tps   com   vertica   状压dp   lan   icpc   bin   esc   

原文地址:https://www.cnblogs.com/Draymonder/p/9571492.html

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!